%test4_hilb.m

disp('Matrice di Hilbert con n=5')
A1=hilb(5);
%vettore dei termini noti
b1=A1*ones(5,1);
%soluzione del sistema lineare A1*x1=b1
disp('Soluzione esatta:')
x1=A1\b1
%perturbazione del vettore b1
br1=b1+rand(5,1);
%soluzione del sistema lineare A1*xr1=br1
disp('Soluzione perturbata: ')
xr1=A1\br1
disp('Errore relativo sulla soluzione: ')
erx1=norm(x1-xr1)/norm(x1)
disp('Errore relativo sui dati iniziali: ')
erb1=norm(b1-br1)/norm(b1)
disp('Condizionamento della matrice di Hilbert: ')
c1=cond(A1)
%--------------------------------------------------
disp('Matrice di Hilbert con n=10')
A2=hilb(10);
%vettore dei termini noti
b2=A2*ones(10,1);
%soluzione del sistema lineare A2*x2=b2
disp('Soluzione esatta:')
x2=A2\b2
%perturbazione del vettore b2
br2=b2+rand(10,1);
%soluzione del sistema lineare A2*xr2=br2
disp('Soluzione perturbata: ')
xr2=A2\br2
disp('Errore relativo sulla soluzione: ')
erx2=norm(x2-xr2)/norm(x2)
disp('Errore relativo sui dati iniziali: ')
erb2=norm(b2-br2)/norm(b2)
disp('Condizionamento della matrice di Hilbert: ')
c2=cond(A2)
%--------------------------------------------------
disp('Matrice di Hilbert con n=20')
A3=hilb(20);
%vettore dei termini noti
b3=A3*ones(20,1);
%soluzione del sistema lineare A3*x3=b3
disp('Soluzione esatta:')
x3=A3\b3
%perturbazione del vettore b3
br3=b3+rand(20,1);
%soluzione del sistema lineare A3*xr3=br3
disp('Soluzione perturbata: ')
xr3=A3\br3
disp('Errore relativo sulla soluzione: ')
erx3=norm(x3-xr3)/norm(x3)
disp('Errore relativo sui dati iniziali: ')
erb3=norm(b3-br3)/norm(b3)
disp('Condizionamento della matrice di Hilbert: ')
c3=cond(A3)
